<?php
require("../LdapManager.php");
require("../LdapConf.php");

$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

header('Content-type: text/xml');
$res="<Export>\n";
if (array_key_exists('dn',$_GET)) {
    $dnEntry=base64_decode($_GET['dn']);
    if (array_key_exists('compress',$_GET)) {
        $compress=$_GET['compress'];
    }
    else {
        $compress="false";
    }
    $ldif='';
    if (array_key_exists('recursive',$_GET)) {
        $recur=$_GET['recursive'];
        if (strcmp($recur,"true")==0) {
            $listEntries=$lm->search($dnEntry,"(objectClass=*)",false);
            foreach ($listEntries as $entryChild) {
                $ldif.="\n";
                $ldif.=$entryChild->getLDIF();
            }
        }
    }
    else {
        $entry=$lm->getEntry($dnEntry);
        $ldif=$entry->getLDIF();
    }
    $res.="<LDIF dnbase='".$dnEntry."'";
    if (strcmp($recur,"true")==0) {
        $res.=" recursive='true'";
    }
    if (strcmp($compress,"true")==0) {
        $res.=" gzip='true'";
    }
    $res.=">";
    if (strcmp($compress,"true")==0) {
        $res.=base64_encode(gzencode($ldif,9));
    }
    else {
        $res.=base64_encode($ldif);
    }
    $res.="</LDIF>";
}
$res.="</Export>\n";

echo $res;
?>
