<?php
require("../LdapManager.php");
require("../LdapConf.php");
require("../xml2Array.php");

$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

function parseObjectClassList($arrayXML,$objClassList) {
    $attributesList=$arrayXML[0]['children'];
    foreach ($attributesList as $attributeXML) {
        $nameAttr=$attributeXML['attrs']['NAME'];
        $attrValuesList=$attributeXML['children'];
        foreach ($attrValuesList as $attrValueXML) {
            $valueAttr=$attrValueXML['attrs']['VALUE'];
            if (strcmp($nameAttr,"objectClass")==0) {
                $objClassList[]=$valueAttr;
            }
        } 
    } 
}

function parseAttributeList($arrayXML,$attrList) {
    $attributesList=$arrayXML[0]['children'];
    foreach ($attributesList as $attributeXML) {
        $nameAttr=$attributeXML['attrs']['NAME'];
        $attrValuesList=$attributeXML['children'];
        foreach ($attrValuesList as $attrValueXML) {
            $valueAttr=$attrValueXML['attrs']['VALUE'];
            if (strcmp($nameAttr,"objectClass")!=0) {
				if (!array_key_exists($nameAttr,$attrList)) {
					$attrList[$nameAttr]=array();
				}
				$attrList[$nameAttr][]=$valueAttr;
            }
        } 
    } 
}

function addChildren($lm,$oldDn,$newDn) {
	$success=true;
	$listChildren=$lm->search($oldDn,"(objectClass=*)",true);
	foreach ($listChildren as $child) {
		$bakDn=$child->getDN();
		$bakRdn=strtok($bakDn,",");
		$newEntryDn=$bakRdn.",".$newDn;
		$objClassList=$child->getObjectClassList();
		$attrList=$child->getAttributeValues();
        if ($lm->addEntry($newEntryDn,$objClassList,$attrList)) {
            $success=addChildren($lm,$bakDn,$newEntryDn);
        }
		else {
			$success=false;
		}
	}
	return $success;
}

$success=false;
header('Content-type: text/xml');
if (array_key_exists('oper',$_POST)) {
    $oper=$_POST['oper'];
    if (strcmp($oper,"addEntry")==0) { // Add a new entry
        if (array_key_exists('entry',$_POST)) {
            $entryXML="<?xml version='1.0' encoding='UTF-8' ?>\n".base64_decode(ereg_replace(" ","+",$_POST['entry']));
            $objXML = new xml2Array();
            
			$arrayXML = $objXML->parse($entryXML);
            $objClassList=array();
            $attrList=array();
            $dn=$arrayXML[0]['attrs']['DN'];
			parseObjectClassList($arrayXML,&$objClassList);
			parseAttributeList($arrayXML,&$attrList);
            if ($lm->addEntry($dn,$objClassList,$attrList)) {
                $success=true;
            }
        }
    }
	else if (strcmp($oper,"replaceEntry")==0) { // Replace an entry
        if (array_key_exists('entry',$_POST)&&array_key_exists('oldDn',$_POST)) {
			$oldDn=base64_decode(ereg_replace(" ","+",$_POST['oldDn']));
            $entryXML="<?xml version='1.0' encoding='UTF-8' ?>\n".base64_decode(ereg_replace(" ","+",$_POST['entry']));
            $objXML = new xml2Array();
            
			$arrayXML = $objXML->parse($entryXML);
            $objClassList=array();
            $attrList=array();
            $dn=$arrayXML[0]['attrs']['DN'];
			parseObjectClassList($arrayXML,&$objClassList);
			parseAttributeList($arrayXML,&$attrList);
			if (strcmp($dn,$oldDn)==0) {
				$oldEntry=$lm->getEntry($oldDn);
				$oldAttrs=$oldEntry->getAttributes();
				if ($lm->replaceEntry($dn,array_keys($oldAttrs),$objClassList,$attrList)) {
					$success=true;
				}
			}
			else {
	            if ($lm->addEntry($dn,$objClassList,$attrList)) {
					$success=addChildren($lm,$oldDn,$dn);
					if ($success==true) {
			            if ($lm->delEntry($oldDn,true)) {
			                $success=true;
			            }
					}
	            }
			}
        }
	}
    else if (strcmp($oper,"delEntry")==0) { // Remove an entry
        if (array_key_exists('dnEntry',$_POST)) {
            $dnEntry=base64_decode($_POST['dnEntry']);
            $delChildren=false;
            if (array_key_exists('delChildren',$_POST)) {
                if (strcmp($_POST['delChildren'],"true")==0) {
                    $delChildren=true;
                }
            }
            if ($lm->delEntry($dnEntry,$delChildren)) {
                $success=true;
            }
        }
    }
}
if ($success==true) {
    echo "<OperationInfo><Status status='success'/></OperationInfo>";
}
else {
    echo "<OperationInfo><Status status='fail'/><ErrorMessage message='".$lm->getErrorMessage()."'/></OperationInfo>";
}

?>
